﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Web.Caching;

namespace WDGTest
{
    public partial class _Default : System.Web.UI.Page
    {
        string TypeBooks = "Books";
        string TypeAnimals = "Animals";

        protected void Page_Load(object sender, EventArgs e)
        {

            if (!Page.IsPostBack){
                //Initially load books
                Session["PreviousType"] = TypeBooks;
            }

            LoadData((string)Session["PreviousType"]);
        }

        private void LoadData(string strType)
        {
            try
            {
                if (Session["PreviousType"] != strType ){
                    ClearGrid();
                }

            string strXMLFile = strType + ".xml";
            string strCacheName = strType;

            DataSet ds = (DataSet)Cache[strCacheName];
            if (ds == null){ 
                ds = new DataSet();
                ds.ReadXml(Server.MapPath(strXMLFile));
                // Set to expire after only 15 seconds for testing purposes.
                Cache.Insert(strCacheName, ds, null, Cache.NoAbsoluteExpiration, new TimeSpan(0, 0, 15));
            }

            WebDataGrid.DataSource = ds;
            //WebDataGrid1.DataBind()

            Session["PreviousType"] = strType;

            }
            catch (Exception ex)
            {
                Response.Write("<h3>Error: " + ex.ToString() + "</h3>");
            }
        }

		protected void pbBooks_Click(object sender, EventArgs e)
		{
            LoadData(TypeBooks);
		}

		protected void pbAnimals_Click(object sender, EventArgs e)
		{
            LoadData(TypeAnimals);
		}

        private void ClearGrid()
        {
            WebDataGrid.Behaviors.Filtering.ClearBehaviorColumnInfo();
            WebDataGrid.Behaviors.Filtering.ApplyFilter();
            WebDataGrid.ClearDataSource();
            WebDataGrid.Behaviors.Sorting.SortedColumns.Clear();
            WebDataGrid.Behaviors.Sorting.ColumnSettings.Clear();
            WebDataGrid.Behaviors.Paging.PageIndex = 0; 
        }
    }
}
